#ifndef MCIDISC_H
#define MCIDISC_H

#include <windows.h>
#include <mmsystem.h>
#include <vector>
#include "../Disc.h"

const unsigned MCI_MAXLEN = 1024;

struct Track
{
  unsigned long start_frame;
  unsigned long frames;
};

class CMciDisc : public CDisc
{
public:
  CMciDisc(const char *device = "cdaudio");
  virtual ~CMciDisc();

  virtual unsigned GetTrackCount() const;
  virtual unsigned long GetStartFrame(unsigned track) const;
  virtual unsigned long GetFrames(unsigned track) const;

private:
  unsigned m_track_count;
  std::vector<Track *> m_track;

  MCIERROR ReadTrackCount(const char *device);
  MCIERROR CreateTracks(const char *device);
  MCIERROR SendString(const char *command, char *result, unsigned buflen = MCI_MAXLEN);
};

#endif // MCIDISC_H
